// Code generated by go_code.py; DO NOT EDIT.

package choose_files
import "fmt"
import "github.com/kovidgoyal/kitty/tools/cli"
var _ = fmt.Sprintf
func create_cmd(root *cli.Command, run_func func(*cli.Command, *Options, []string)(int, error)) {
ans := root.AddSubCommand(&cli.Command{
Name: "choose_files",
ShortDescription: "Choose files, fast",
Usage: "[options] [directory to start choosing files in]",
HelpText: "",
Run: func(cmd *cli.Command, args []string) (int, error) {
opts := Options{}
err := cmd.GetOptionValues(&opts)
if err != nil { return 1, err }
return run_func(cmd, &opts, args)},
Hidden: true,
})
ans.Add(cli.OptionSpec{
            Name: "--override -o",
            Type: "list",
            Dest: "Override",
            Help: "Override individual configuration options, can be specified multiple times. Syntax: :italic:`name=value`.",
        })
ans.Add(cli.OptionSpec{
            Name: "--config",
            Type: "list",
            Dest: "Config",
            Help: "Specify a path to the configuration file(s) to use. All configuration files are merged onto the builtin :file:`diff.conf`, overriding the builtin values. This option can be specified multiple times to read multiple configuration files in sequence, which are merged. Use the special value :code:`NONE` to not load any config file.\n\nIf this option is not specified, config files are searched for in the order: :file:`$XDG_CONFIG_HOME/kitty/diff.conf`, :file:`~/.config/kitty/diff.conf`, :file:`$XDG_CONFIG_DIRS/kitty/diff.conf`. The first one that exists is used as the config file.\n\nIf the environment variable :envvar:`KITTY_CONFIG_DIRECTORY` is specified, that directory is always used and the above searching does not happen.\n\nIf :file:`/etc/xdg/kitty/diff.conf` exists, it is merged before (i.e. with lower priority) than any user config files. It can be used to specify system-wide defaults for all users. You can use either :code:`-` or :file:`/dev/stdin` to read the config from STDIN.",
        Completer: cli.ChainCompleters(cli.NamesCompleter("Keywords", "none", "NONE"), cli.FnmatchCompleter("Config files", cli.CWD, "*.conf")),})
ans.Add(cli.OptionSpec{
            Name: "--mode",
            Type: "choices",
            Dest: "Mode",
            Help: "The type of object(s) to select",
        
Choices: "file, dir, dir-for-files, dirs, files, save-dir, save-file",

Completer: cli.NamesCompleter("Choices for mode", "file", "dir", "dir-for-files", "dirs", "files", "save-dir", "save-file"),
	Default: "file",
})
ans.Add(cli.OptionSpec{
            Name: "--suggested-save-file-name",
            Type: "",
            Dest: "SuggestedSaveFileName",
            Help: "A suggested name when picking a save file.",
        })
ans.Add(cli.OptionSpec{
            Name: "--suggested-save-file-path",
            Type: "",
            Dest: "SuggestedSaveFilePath",
            Help: "Path to an existing file to use as the save file.",
        })
ans.ArgCompleter = cli.DirectoryCompleter("Directories", cli.CWD)
clone := root.AddClone(ans.Group, ans)
clone.Hidden = false
clone.Name = "choose-files"
}
type Options struct {
Override []string
Config []string
Mode string
SuggestedSaveFileName string
SuggestedSaveFilePath string
}
func (opts Options) AsCommandLine() (ans []string) {
	 sval := ""
	 _ = sval
		for _, x := range opts.Override { ans = append(ans, `--override=` + x) }
		for _, x := range opts.Config { ans = append(ans, `--config=` + x) }
	sval = opts.Mode
	if (sval != "file") { ans = append(ans, `--mode=` + sval)}
	sval = opts.SuggestedSaveFileName
	if (sval != "") { ans = append(ans, `--suggested-save-file-name=` + sval)}
	sval = opts.SuggestedSaveFilePath
	if (sval != "") { ans = append(ans, `--suggested-save-file-path=` + sval)}
return
}
